/***************************************************************************
                          klineakconfig.h  -  description
                             -------------------
    begin                : Tue Apr  9 18:33:44 EDT 2002
    copyright            : (C) 2002 by Sheldon Lee Wen
    email                : tormak@rogers.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KLINEAKCONFIG_H
#define KLINEAKCONFIG_H

#define gint int
#define g_print printf
#define gboolean int
#define g_warning printf


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <signal.h>
#include <kapp.h>
#include <qwidget.h>
#include <klineakconfigui.h>
#include <hash_map.h>
#include <qstring.h>

#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qmessagebox.h>
#include <qstring.h>
#include <kstddirs.h>

/** KlineakConfig is the base class of the project */
class KlineakConfig : public KlineakConfigUI
{
  Q_OBJECT 
  public:
    /** construtor */
    KlineakConfig(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KlineakConfig();
    QWidget* getWidget(QString name);

   private:
		bool ApplyUsed;

   public slots:
       virtual void updateKeyList(int index);
       virtual void updateKeyList(const QString& inText);
       virtual void onKeyListSelect(QListBoxItem *box);
       virtual void updateAvailableKeys(int i);
       virtual void updateCDRom();
       virtual void quit();
       virtual void onOKButtonClicked();
       virtual bool onApplyButtonClicked();
};

#endif
