/***************************************************************************
                          support.h  -  description
                             -------------------
    begin                : Tue Apr 9 2002
    copyright            : (C) 2002 by Sheldon Lee Wen
    email                : tormak@rogers.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef SUPPORT_H
#define SUPPORT_H

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include <X11/extensions/XKBfile.h>


/*#include "lineakconfig.h"*/
#include "supportpriv.h"
#include "defines.h"

/* Standard gettext macros. */
#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif


/**********************************************************************************************/

/* EAKey as member of list */
typedef struct strEAkey {
  struct strEAkey *next;
  char *EAkeyname;
  int EAkeycode;
  KeySym EAkeysym;
  char *EAcommand;
} EAkey;

/* the EAK we will use.. */
typedef struct {
  int EAKnr;
  char *EAKtype;
  char *EAKname;
  EAkey *EAKeylist;
} EAKeyboard;

EAKeyboard myEAK;

/* function prototypes */
int parseconffile(void);
int parsedeffile(void);
int initEAK (void);
void cleanKeylist (void);
int cleanexit(void);
gboolean backup_conffile (void);
gboolean restore_conffile (void);
gboolean save_conffile (void);
gint get_lineakd_pid(void);

gboolean changing_text_from_signal = FALSE;
char *kbtype, *cdromdev;
int selected_key;

#endif
